diff a/src/hotspot/share/gc/shenandoah/c2/shenandoahBarrierSetC2.cpp b/src/hotspot/share/gc/shenandoah/c2/shenandoahBarrierSetC2.cpp
--- a/src/hotspot/share/gc/shenandoah/c2/shenandoahBarrierSetC2.cpp
+++ b/src/hotspot/share/gc/shenandoah/c2/shenandoahBarrierSetC2.cpp
@@ -943,380 +501,118 @@
   }
 }
 
 
 // Support for macro expanded GC barriers
-void ShenandoahBarrierSetC2::register_potential_barrier_node(Node* node) const {
-  if (node->Opcode() == Op_ShenandoahLoadReferenceBarrier) {
-    state()->add_load_reference_barrier((ShenandoahLoadReferenceBarrierNode*) node);
-  }
-}
-
-void ShenandoahBarrierSetC2::unregister_potential_barrier_node(Node* node) const {
-  if (node->Opcode() == Op_ShenandoahLoadReferenceBarrier) {
-    state()->remove_load_reference_barrier((ShenandoahLoadReferenceBarrierNode*) node);
+void ShenandoahBarrierSetC2::eliminate_gc_barrier_data(Node* node) const {
+  if (node->is_LoadStore()) {
+    LoadStoreNode* loadstore = node->as_LoadStore();
+    loadstore->set_barrier_data(0);
+  } else if (node->is_Mem()) {
+    MemNode* mem = node->as_Mem();
+    mem->set_barrier_data(0);
   }
 }
 
 void ShenandoahBarrierSetC2::eliminate_gc_barrier(PhaseMacroExpand* macro, Node* node) const {
-  if (is_shenandoah_wb_pre_call(node)) {
-    shenandoah_eliminate_wb_pre(node, &macro->igvn());
-  }
-  if (ShenandoahCardBarrier && node->Opcode() == Op_CastP2X) {
-    Node* shift = node->unique_out();
-    Node* addp = shift->unique_out();
-    for (DUIterator_Last jmin, j = addp->last_outs(jmin); j >= jmin; --j) {
-      Node* mem = addp->last_out(j);
-      if (UseCondCardMark && mem->is_Load()) {
-        assert(mem->Opcode() == Op_LoadB, "unexpected code shape");
-        // The load is checking if the card has been written so
-        // replace it with zero to fold the test.
-        macro->replace_node(mem, macro->intcon(0));
-        continue;
-      }
-      assert(mem->is_Store(), "store required");
-      macro->replace_node(mem, mem->in(MemNode::Memory));
-    }
-  }
-}
-
-void ShenandoahBarrierSetC2::shenandoah_eliminate_wb_pre(Node* call, PhaseIterGVN* igvn) const {
-  assert(UseShenandoahGC && is_shenandoah_wb_pre_call(call), "");
-  Node* c = call->as_Call()->proj_out(TypeFunc::Control);
-  c = c->unique_ctrl_out();
-  assert(c->is_Region() && c->req() == 3, "where's the pre barrier control flow?");
-  c = c->unique_ctrl_out();
-  assert(c->is_Region() && c->req() == 3, "where's the pre barrier control flow?");
-  Node* iff = c->in(1)->is_IfProj() ? c->in(1)->in(0) : c->in(2)->in(0);
-  assert(iff->is_If(), "expect test");
-  if (!is_shenandoah_marking_if(igvn, iff)) {
-    c = c->unique_ctrl_out();
-    assert(c->is_Region() && c->req() == 3, "where's the pre barrier control flow?");
-    iff = c->in(1)->is_IfProj() ? c->in(1)->in(0) : c->in(2)->in(0);
-    assert(is_shenandoah_marking_if(igvn, iff), "expect marking test");
-  }
-  Node* cmpx = iff->in(1)->in(1);
-  igvn->replace_node(cmpx, igvn->makecon(TypeInt::CC_EQ));
-  igvn->rehash_node_delayed(call);
-  call->del_req(call->req()-1);
-}
-
-void ShenandoahBarrierSetC2::enqueue_useful_gc_barrier(PhaseIterGVN* igvn, Node* node) const {
-  if (node->Opcode() == Op_AddP && ShenandoahBarrierSetC2::has_only_shenandoah_wb_pre_uses(node)) {
-    igvn->add_users_to_worklist(node);
-  }
-}
-
-void ShenandoahBarrierSetC2::eliminate_useless_gc_barriers(Unique_Node_List &useful, Compile* C) const {
-  for (uint i = 0; i < useful.size(); i++) {
-    Node* n = useful.at(i);
-    if (n->Opcode() == Op_AddP && ShenandoahBarrierSetC2::has_only_shenandoah_wb_pre_uses(n)) {
-      for (DUIterator_Fast imax, i = n->fast_outs(imax); i < imax; i++) {
-        C->record_for_igvn(n->fast_out(i));
-      }
-    }
-  }
-
-  for (int i = state()->load_reference_barriers_count() - 1; i >= 0; i--) {
-    ShenandoahLoadReferenceBarrierNode* n = state()->load_reference_barrier(i);
-    if (!useful.member(n)) {
-      state()->remove_load_reference_barrier(n);
-    }
-  }
+  eliminate_gc_barrier_data(node);
 }
 
 void* ShenandoahBarrierSetC2::create_barrier_state(Arena* comp_arena) const {
   return new(comp_arena) ShenandoahBarrierSetC2State(comp_arena);
 }
 
 ShenandoahBarrierSetC2State* ShenandoahBarrierSetC2::state() const {
   return reinterpret_cast<ShenandoahBarrierSetC2State*>(Compile::current()->barrier_set_state());
 }
 
-// If the BarrierSetC2 state has kept macro nodes in its compilation unit state to be
-// expanded later, then now is the time to do so.
-bool ShenandoahBarrierSetC2::expand_macro_nodes(PhaseMacroExpand* macro) const { return false; }
-
 #ifdef ASSERT
 void ShenandoahBarrierSetC2::verify_gc_barriers(Compile* compile, CompilePhase phase) const {
-  if (ShenandoahVerifyOptoBarriers && phase == BarrierSetC2::BeforeMacroExpand) {
-    ShenandoahBarrierC2Support::verify(Compile::current()->root());
-  } else if (phase == BarrierSetC2::BeforeCodeGen) {
-    // Verify Shenandoah pre-barriers
-    const int gc_state_offset = in_bytes(ShenandoahThreadLocalData::gc_state_offset());
-
-    Unique_Node_List visited;
-    Node_List worklist;
-    // We're going to walk control flow backwards starting from the Root
-    worklist.push(compile->root());
-    while (worklist.size() > 0) {
-      Node *x = worklist.pop();
-      if (x == nullptr || x == compile->top()) {
-        continue;
-      }
-
-      if (visited.member(x)) {
-        continue;
-      } else {
-        visited.push(x);
-      }
-
-      if (x->is_Region()) {
-        for (uint i = 1; i < x->req(); i++) {
-          worklist.push(x->in(i));
-        }
-      } else {
-        worklist.push(x->in(0));
-        // We are looking for the pattern:
-        //                            /->ThreadLocal
-        // If->Bool->CmpI->LoadB->AddP->ConL(marking_offset)
-        //              \->ConI(0)
-        // We want to verify that the If and the LoadB have the same control
-        // See GraphKit::g1_write_barrier_pre()
-        if (x->is_If()) {
-          IfNode *iff = x->as_If();
-          if (iff->in(1)->is_Bool() && iff->in(1)->in(1)->is_Cmp()) {
-            CmpNode *cmp = iff->in(1)->in(1)->as_Cmp();
-            if (cmp->Opcode() == Op_CmpI && cmp->in(2)->is_Con() && cmp->in(2)->bottom_type()->is_int()->get_con() == 0
-                && cmp->in(1)->is_Load()) {
-              LoadNode *load = cmp->in(1)->as_Load();
-              if (load->Opcode() == Op_LoadB && load->in(2)->is_AddP() && load->in(2)->in(2)->Opcode() == Op_ThreadLocal
-                  && load->in(2)->in(3)->is_Con()
-                  && load->in(2)->in(3)->bottom_type()->is_intptr_t()->get_con() == gc_state_offset) {
-
-                Node *if_ctrl = iff->in(0);
-                Node *load_ctrl = load->in(0);
-
-                if (if_ctrl != load_ctrl) {
-                  // Skip possible CProj->NeverBranch in infinite loops
-                  if ((if_ctrl->is_Proj() && if_ctrl->Opcode() == Op_CProj)
-                      && if_ctrl->in(0)->is_NeverBranch()) {
-                    if_ctrl = if_ctrl->in(0)->in(0);
-                  }
-                }
-                assert(load_ctrl != nullptr && if_ctrl == load_ctrl, "controls must match");
-              }
-            }
-          }
-        }
-      }
-    }
-  }
+  // TODO: Re-implement C2 barrier verification.
 }
 #endif
 
-Node* ShenandoahBarrierSetC2::ideal_node(PhaseGVN* phase, Node* n, bool can_reshape) const {
-  if (is_shenandoah_wb_pre_call(n)) {
-    uint cnt = ShenandoahBarrierSetC2::write_barrier_pre_Type()->domain()->cnt();
-    if (n->req() > cnt) {
-      Node* addp = n->in(cnt);
-      if (has_only_shenandoah_wb_pre_uses(addp)) {
-        n->del_req(cnt);
-        if (can_reshape) {
-          phase->is_IterGVN()->_worklist.push(addp);
-        }
-        return n;
-      }
-    }
+static ShenandoahBarrierSetC2State* barrier_set_state() {
+  return reinterpret_cast<ShenandoahBarrierSetC2State*>(Compile::current()->barrier_set_state());
+}
+
+int ShenandoahBarrierSetC2::estimate_stub_size() const {
+  Compile* const C = Compile::current();
+  BufferBlob* const blob = C->output()->scratch_buffer_blob();
+  GrowableArray<ShenandoahBarrierStubC2*>* const stubs = barrier_set_state()->stubs();
+  int size = 0;
+
+  for (int i = 0; i < stubs->length(); i++) {
+    CodeBuffer cb(blob->content_begin(), checked_cast<CodeBuffer::csize_t>((address)C->output()->scratch_locs_memory() - blob->content_begin()));
+    MacroAssembler masm(&cb);
+    stubs->at(i)->emit_code(masm);
+    size += cb.insts_size();
   }
-  if (n->Opcode() == Op_CmpP) {
-    Node* in1 = n->in(1);
-    Node* in2 = n->in(2);
-
-    // If one input is null, then step over the strong LRB barriers on the other input
-    if (in1->bottom_type() == TypePtr::NULL_PTR &&
-        !((in2->Opcode() == Op_ShenandoahLoadReferenceBarrier) &&
-          !ShenandoahBarrierSet::is_strong_access(((ShenandoahLoadReferenceBarrierNode*)in2)->decorators()))) {
-      in2 = step_over_gc_barrier(in2);
-    }
-    if (in2->bottom_type() == TypePtr::NULL_PTR &&
-        !((in1->Opcode() == Op_ShenandoahLoadReferenceBarrier) &&
-          !ShenandoahBarrierSet::is_strong_access(((ShenandoahLoadReferenceBarrierNode*)in1)->decorators()))) {
-      in1 = step_over_gc_barrier(in1);
-    }
 
-    if (in1 != n->in(1)) {
-      n->set_req_X(1, in1, phase);
-      assert(in2 == n->in(2), "only one change");
-      return n;
-    }
-    if (in2 != n->in(2)) {
-      n->set_req_X(2, in2, phase);
-      return n;
-    }
-  } else if (can_reshape &&
-             n->Opcode() == Op_If &&
-             ShenandoahBarrierC2Support::is_heap_stable_test(n) &&
-             n->in(0) != nullptr &&
-             n->outcnt() == 2) {
-    Node* dom = n->in(0);
-    Node* prev_dom = n;
-    int op = n->Opcode();
-    int dist = 16;
-    // Search up the dominator tree for another heap stable test
-    while (dom->Opcode() != op    ||  // Not same opcode?
-           !ShenandoahBarrierC2Support::is_heap_stable_test(dom) ||  // Not same input 1?
-           prev_dom->in(0) != dom) {  // One path of test does not dominate?
-      if (dist < 0) return nullptr;
-
-      dist--;
-      prev_dom = dom;
-      dom = IfNode::up_one_dom(dom);
-      if (!dom) return nullptr;
-    }
+  return size;
+}
+
+void ShenandoahBarrierSetC2::emit_stubs(CodeBuffer& cb) const {
+  MacroAssembler masm(&cb);
+  GrowableArray<ShenandoahBarrierStubC2*>* const stubs = barrier_set_state()->stubs();
+  barrier_set_state()->set_stubs_start_offset(masm.offset());
 
-    // Check that we did not follow a loop back to ourselves
-    if (n == dom) {
-      return nullptr;
+  for (int i = 0; i < stubs->length(); i++) {
+    // Make sure there is enough space in the code buffer
+    if (cb.insts()->maybe_expand_to_ensure_remaining(PhaseOutput::MAX_inst_size) && cb.blob() == nullptr) {
+      ciEnv::current()->record_failure("CodeCache is full");
+      return;
     }
 
-    return n->as_If()->dominated_by(prev_dom, phase->is_IterGVN(), false);
+    stubs->at(i)->emit_code(masm);
   }
 
-  return nullptr;
+  masm.flush();
+
 }
 
-bool ShenandoahBarrierSetC2::has_only_shenandoah_wb_pre_uses(Node* n) {
-  for (DUIterator_Fast imax, i = n->fast_outs(imax); i < imax; i++) {
-    Node* u = n->fast_out(i);
-    if (!is_shenandoah_wb_pre_call(u)) {
-      return false;
-    }
+void ShenandoahBarrierStubC2::register_stub() {
+  if (!Compile::current()->output()->in_scratch_emit_size()) {
+    barrier_set_state()->stubs()->append(this);
   }
-  return n->outcnt() > 0;
 }
 
-bool ShenandoahBarrierSetC2::final_graph_reshaping(Compile* compile, Node* n, uint opcode, Unique_Node_List& dead_nodes) const {
-  switch (opcode) {
-    case Op_CallLeaf:
-    case Op_CallLeafNoFP: {
-      assert (n->is_Call(), "");
-      CallNode *call = n->as_Call();
-      if (ShenandoahBarrierSetC2::is_shenandoah_wb_pre_call(call)) {
-        uint cnt = ShenandoahBarrierSetC2::write_barrier_pre_Type()->domain()->cnt();
-        if (call->req() > cnt) {
-          assert(call->req() == cnt + 1, "only one extra input");
-          Node *addp = call->in(cnt);
-          assert(!ShenandoahBarrierSetC2::has_only_shenandoah_wb_pre_uses(addp), "useless address computation?");
-          call->del_req(cnt);
-        }
-      }
-      return false;
-    }
-    case Op_ShenandoahCompareAndSwapP:
-    case Op_ShenandoahCompareAndSwapN:
-    case Op_ShenandoahWeakCompareAndSwapN:
-    case Op_ShenandoahWeakCompareAndSwapP:
-    case Op_ShenandoahCompareAndExchangeP:
-    case Op_ShenandoahCompareAndExchangeN:
-      return true;
-    case Op_ShenandoahLoadReferenceBarrier:
-      assert(false, "should have been expanded already");
-      return true;
-    default:
-      return false;
-  }
+ShenandoahLoadRefBarrierStubC2* ShenandoahLoadRefBarrierStubC2::create(const MachNode* node, Register obj, Register addr, Register tmp1, Register tmp2, Register tmp3, bool narrow) {
+  auto* stub = new (Compile::current()->comp_arena()) ShenandoahLoadRefBarrierStubC2(node, obj, addr, tmp1, tmp2, tmp3, narrow);
+  stub->register_stub();
+  return stub;
 }
 
-bool ShenandoahBarrierSetC2::escape_add_to_con_graph(ConnectionGraph* conn_graph, PhaseGVN* gvn, Unique_Node_List* delayed_worklist, Node* n, uint opcode) const {
-  switch (opcode) {
-    case Op_ShenandoahCompareAndExchangeP:
-    case Op_ShenandoahCompareAndExchangeN:
-      conn_graph->add_objload_to_connection_graph(n, delayed_worklist);
-      // fallthrough
-    case Op_ShenandoahWeakCompareAndSwapP:
-    case Op_ShenandoahWeakCompareAndSwapN:
-    case Op_ShenandoahCompareAndSwapP:
-    case Op_ShenandoahCompareAndSwapN:
-      conn_graph->add_to_congraph_unsafe_access(n, opcode, delayed_worklist);
-      return true;
-    case Op_StoreP: {
-      Node* adr = n->in(MemNode::Address);
-      const Type* adr_type = gvn->type(adr);
-      // Pointer stores in Shenandoah barriers looks like unsafe access.
-      // Ignore such stores to be able scalar replace non-escaping
-      // allocations.
-      if (adr_type->isa_rawptr() && adr->is_AddP()) {
-        Node* base = conn_graph->get_addp_base(adr);
-        if (base->Opcode() == Op_LoadP &&
-          base->in(MemNode::Address)->is_AddP()) {
-          adr = base->in(MemNode::Address);
-          Node* tls = conn_graph->get_addp_base(adr);
-          if (tls->Opcode() == Op_ThreadLocal) {
-             int offs = (int) gvn->find_intptr_t_con(adr->in(AddPNode::Offset), Type::OffsetBot);
-             const int buf_offset = in_bytes(ShenandoahThreadLocalData::satb_mark_queue_buffer_offset());
-             if (offs == buf_offset) {
-               return true; // Pre barrier previous oop value store.
-             }
-          }
-        }
-      }
-      return false;
-    }
-    case Op_ShenandoahLoadReferenceBarrier:
-      conn_graph->add_local_var_and_edge(n, PointsToNode::NoEscape, n->in(ShenandoahLoadReferenceBarrierNode::ValueIn), delayed_worklist);
-      return true;
-    default:
-      // Nothing
-      break;
-  }
-  return false;
+ShenandoahSATBBarrierStubC2* ShenandoahSATBBarrierStubC2::create(const MachNode* node, Register addr, Register preval, Register tmp) {
+  auto* stub = new (Compile::current()->comp_arena()) ShenandoahSATBBarrierStubC2(node, addr, preval, tmp);
+  stub->register_stub();
+  return stub;
 }
 
-bool ShenandoahBarrierSetC2::escape_add_final_edges(ConnectionGraph* conn_graph, PhaseGVN* gvn, Node* n, uint opcode) const {
-  switch (opcode) {
-    case Op_ShenandoahCompareAndExchangeP:
-    case Op_ShenandoahCompareAndExchangeN: {
-      Node *adr = n->in(MemNode::Address);
-      conn_graph->add_local_var_and_edge(n, PointsToNode::NoEscape, adr, nullptr);
-      // fallthrough
-    }
-    case Op_ShenandoahCompareAndSwapP:
-    case Op_ShenandoahCompareAndSwapN:
-    case Op_ShenandoahWeakCompareAndSwapP:
-    case Op_ShenandoahWeakCompareAndSwapN:
-      return conn_graph->add_final_edges_unsafe_access(n, opcode);
-    case Op_ShenandoahLoadReferenceBarrier:
-      conn_graph->add_local_var_and_edge(n, PointsToNode::NoEscape, n->in(ShenandoahLoadReferenceBarrierNode::ValueIn), nullptr);
-      return true;
-    default:
-      // Nothing
-      break;
-  }
-  return false;
+ShenandoahCASBarrierSlowStubC2* ShenandoahCASBarrierSlowStubC2::create(const MachNode* node, Register addr, Register expected, Register new_val, Register result, Register tmp, bool cae, bool acquire, bool release, bool weak) {
+  auto* stub = new (Compile::current()->comp_arena()) ShenandoahCASBarrierSlowStubC2(node, addr, Address(), expected, new_val, result, tmp, noreg, cae, acquire, release, weak);
+  stub->register_stub();
+  return stub;
 }
 
-bool ShenandoahBarrierSetC2::escape_has_out_with_unsafe_object(Node* n) const {
-  return n->has_out_with(Op_ShenandoahCompareAndExchangeP) || n->has_out_with(Op_ShenandoahCompareAndExchangeN) ||
-         n->has_out_with(Op_ShenandoahCompareAndSwapP, Op_ShenandoahCompareAndSwapN, Op_ShenandoahWeakCompareAndSwapP, Op_ShenandoahWeakCompareAndSwapN);
+ShenandoahCASBarrierSlowStubC2* ShenandoahCASBarrierSlowStubC2::create(const MachNode* node, Address addr, Register expected, Register new_val, Register result, Register tmp1, Register tmp2, bool cae) {
+  auto* stub = new (Compile::current()->comp_arena()) ShenandoahCASBarrierSlowStubC2(node, noreg, addr, expected, new_val, result, tmp1, tmp2, cae, false, false, false);
+  stub->register_stub();
+  return stub;
+}
 
+ShenandoahCASBarrierMidStubC2* ShenandoahCASBarrierMidStubC2::create(const MachNode* node, ShenandoahCASBarrierSlowStubC2* slow_stub, Register expected, Register result, Register tmp, bool cae) {
+  auto* stub = new (Compile::current()->comp_arena()) ShenandoahCASBarrierMidStubC2(node, slow_stub, expected, result, tmp, cae);
+  stub->register_stub();
+  return stub;
 }
 
-bool ShenandoahBarrierSetC2::matcher_find_shared_post_visit(Matcher* matcher, Node* n, uint opcode) const {
-  switch (opcode) {
-    case Op_ShenandoahCompareAndExchangeP:
-    case Op_ShenandoahCompareAndExchangeN:
-    case Op_ShenandoahWeakCompareAndSwapP:
-    case Op_ShenandoahWeakCompareAndSwapN:
-    case Op_ShenandoahCompareAndSwapP:
-    case Op_ShenandoahCompareAndSwapN: {   // Convert trinary to binary-tree
-      Node* newval = n->in(MemNode::ValueIn);
-      Node* oldval = n->in(LoadStoreConditionalNode::ExpectedIn);
-      Node* pair = new BinaryNode(oldval, newval);
-      n->set_req(MemNode::ValueIn,pair);
-      n->del_req(LoadStoreConditionalNode::ExpectedIn);
-      return true;
-    }
-    default:
-      break;
-  }
-  return false;
+bool ShenandoahBarrierSetC2State::needs_liveness_data(const MachNode* mach) const {
+  //assert(mach->barrier_data() != 0, "what else?");
+  // return mach->barrier_data() != 0;
+  //return (mach->barrier_data() & ShenandoahSATBBarrier) != 0;
+  return ShenandoahSATBBarrierStubC2::needs_barrier(mach) || ShenandoahLoadRefBarrierStubC2::needs_barrier(mach);
 }
 
-bool ShenandoahBarrierSetC2::matcher_is_store_load_barrier(Node* x, uint xop) const {
-  return xop == Op_ShenandoahCompareAndExchangeP ||
-         xop == Op_ShenandoahCompareAndExchangeN ||
-         xop == Op_ShenandoahWeakCompareAndSwapP ||
-         xop == Op_ShenandoahWeakCompareAndSwapN ||
-         xop == Op_ShenandoahCompareAndSwapN ||
-         xop == Op_ShenandoahCompareAndSwapP;
+bool ShenandoahBarrierSetC2State::needs_livein_data() const {
+  return true;
 }
diff a/src/hotspot/share/gc/shenandoah/c2/shenandoahBarrierSetC2.hpp b/src/hotspot/share/gc/shenandoah/c2/shenandoahBarrierSetC2.hpp
--- a/src/hotspot/share/gc/shenandoah/c2/shenandoahBarrierSetC2.hpp
+++ b/src/hotspot/share/gc/shenandoah/c2/shenandoahBarrierSetC2.hpp
@@ -23,64 +23,48 @@
  */
 
 #ifndef SHARE_GC_SHENANDOAH_C2_SHENANDOAHBARRIERSETC2_HPP
 #define SHARE_GC_SHENANDOAH_C2_SHENANDOAHBARRIERSETC2_HPP
 
+#include "shenandoahBarrierSetC2.hpp"
 #include "gc/shared/c2/barrierSetC2.hpp"
-#include "gc/shenandoah/c2/shenandoahSupport.hpp"
 #include "utilities/growableArray.hpp"
 
-class ShenandoahBarrierSetC2State : public ArenaObj {
-private:
-  GrowableArray<ShenandoahLoadReferenceBarrierNode*>* _load_reference_barriers;
+static const uint8_t ShenandoahBarrierStrong          = 1 << 0;
+static const uint8_t ShenandoahBarrierWeak            = 1 << 1;
+static const uint8_t ShenandoahBarrierPhantom         = 1 << 2;
+static const uint8_t ShenandoahBarrierNative          = 1 << 3;
+static const uint8_t ShenandoahBarrierElided          = 1 << 4;
+static const uint8_t ShenandoahBarrierSATB            = 1 << 5;
+static const uint8_t ShenandoahBarrierCardMark        = 1 << 6;
+static const uint8_t ShenandoahBarrierCardMarkNotNull = 1 << 7;
+
+class ShenandoahBarrierStubC2;
+
+class ShenandoahBarrierSetC2State : public BarrierSetC2State {
+  GrowableArray<ShenandoahBarrierStubC2*>* _stubs;
+  int _stubs_start_offset;
 
 public:
-  ShenandoahBarrierSetC2State(Arena* comp_arena);
+  explicit ShenandoahBarrierSetC2State(Arena* comp_arena);
 
-  int load_reference_barriers_count() const;
-  ShenandoahLoadReferenceBarrierNode* load_reference_barrier(int idx) const;
-  void add_load_reference_barrier(ShenandoahLoadReferenceBarrierNode* n);
-  void remove_load_reference_barrier(ShenandoahLoadReferenceBarrierNode * n);
-};
+  bool needs_liveness_data(const MachNode* mach) const override;
+  bool needs_livein_data() const override;
+
+  GrowableArray<ShenandoahBarrierStubC2*>* stubs() {
+    return _stubs;
+  }
+
+  void set_stubs_start_offset(int offset) {
+    _stubs_start_offset = offset;
+  }
+
+  int stubs_start_offset() {
+    return _stubs_start_offset;
+  }};
 
 class ShenandoahBarrierSetC2 : public BarrierSetC2 {
-private:
-  void shenandoah_eliminate_wb_pre(Node* call, PhaseIterGVN* igvn) const;
-
-  bool satb_can_remove_pre_barrier(GraphKit* kit, PhaseValues* phase, Node* adr,
-                                   BasicType bt, uint adr_idx) const;
-  void satb_write_barrier_pre(GraphKit* kit, bool do_load,
-                              Node* obj,
-                              Node* adr,
-                              uint alias_idx,
-                              Node* val,
-                              const TypeOopPtr* val_type,
-                              Node* pre_val,
-                              BasicType bt) const;
-
-  void shenandoah_write_barrier_pre(GraphKit* kit,
-                                    bool do_load,
-                                    Node* obj,
-                                    Node* adr,
-                                    uint alias_idx,
-                                    Node* val,
-                                    const TypeOopPtr* val_type,
-                                    Node* pre_val,
-                                    BasicType bt) const;
-
-  void post_barrier(GraphKit* kit,
-                    Node* ctl,
-                    Node* store,
-                    Node* obj,
-                    Node* adr,
-                    uint adr_idx,
-                    Node* val,
-                    BasicType bt,
-                    bool use_precise) const;
-
-  void insert_pre_barrier(GraphKit* kit, Node* base_oop, Node* offset,
-                          Node* pre_val, bool need_mem_bar) const;
 
   static bool clone_needs_barrier(Node* src, PhaseGVN& gvn);
 
 protected:
   virtual Node* load_at_resolved(C2Access& access, const Type* val_type) const;
@@ -92,64 +76,119 @@
   virtual Node* atomic_xchg_at_resolved(C2AtomicParseAccess& access, Node* new_val, const Type* val_type) const;
 
 public:
   static ShenandoahBarrierSetC2* bsc2();
 
-  static bool is_shenandoah_wb_pre_call(Node* call);
   static bool is_shenandoah_clone_call(Node* call);
-  static bool is_shenandoah_lrb_call(Node* call);
-  static bool is_shenandoah_marking_if(PhaseValues* phase, Node* n);
-  static bool is_shenandoah_state_load(Node* n);
-  static bool has_only_shenandoah_wb_pre_uses(Node* n);
 
   ShenandoahBarrierSetC2State* state() const;
 
-  static const TypeFunc* write_barrier_pre_Type();
   static const TypeFunc* clone_barrier_Type();
-  static const TypeFunc* load_reference_barrier_Type();
-  virtual bool has_load_barrier_nodes() const { return true; }
 
   // This is the entry-point for the backend to perform accesses through the Access API.
   virtual void clone_at_expansion(PhaseMacroExpand* phase, ArrayCopyNode* ac) const;
 
   // These are general helper methods used by C2
   virtual bool array_copy_requires_gc_barriers(bool tightly_coupled_alloc, BasicType type, bool is_clone, bool is_clone_instance, ArrayCopyPhase phase) const;
 
   // Support for GC barriers emitted during parsing
-  virtual bool is_gc_pre_barrier_node(Node* node) const;
   virtual bool is_gc_barrier_node(Node* node) const;
-  virtual Node* step_over_gc_barrier(Node* c) const;
   virtual bool expand_barriers(Compile* C, PhaseIterGVN& igvn) const;
-  virtual bool optimize_loops(PhaseIdealLoop* phase, LoopOptsMode mode, VectorSet& visited, Node_Stack& nstack, Node_List& worklist) const;
-  virtual bool strip_mined_loops_expanded(LoopOptsMode mode) const { return mode == LoopOptsShenandoahExpand; }
-  virtual bool is_gc_specific_loop_opts_pass(LoopOptsMode mode) const { return mode == LoopOptsShenandoahExpand; }
 
   // Support for macro expanded GC barriers
-  virtual void register_potential_barrier_node(Node* node) const;
-  virtual void unregister_potential_barrier_node(Node* node) const;
   virtual void eliminate_gc_barrier(PhaseMacroExpand* macro, Node* node) const;
-  virtual void enqueue_useful_gc_barrier(PhaseIterGVN* igvn, Node* node) const;
-  virtual void eliminate_useless_gc_barriers(Unique_Node_List &useful, Compile* C) const;
+  virtual void eliminate_gc_barrier_data(Node* node) const;
 
   // Allow barrier sets to have shared state that is preserved across a compilation unit.
   // This could for example comprise macro nodes to be expanded during macro expansion.
   virtual void* create_barrier_state(Arena* comp_arena) const;
-  // If the BarrierSetC2 state has kept macro nodes in its compilation unit state to be
-  // expanded later, then now is the time to do so.
-  virtual bool expand_macro_nodes(PhaseMacroExpand* macro) const;
 
 #ifdef ASSERT
   virtual void verify_gc_barriers(Compile* compile, CompilePhase phase) const;
 #endif
 
-  virtual Node* ideal_node(PhaseGVN* phase, Node* n, bool can_reshape) const;
-  virtual bool final_graph_reshaping(Compile* compile, Node* n, uint opcode, Unique_Node_List& dead_nodes) const;
+  int estimate_stub_size() const /* override */;
+  void emit_stubs(CodeBuffer& cb) const /* override */;
+  void late_barrier_analysis() const /* override*/ {
+    compute_liveness_at_stubs();
+  }
+
+};
+
+class ShenandoahBarrierStubC2 : public BarrierStubC2 {
+protected:
+  explicit ShenandoahBarrierStubC2(const MachNode* node) : BarrierStubC2(node) {}
+  void register_stub();
+public:
+  virtual void emit_code(MacroAssembler& masm) = 0;
+};
+
+class ShenandoahLoadRefBarrierStubC2 : public ShenandoahBarrierStubC2 {
+  Register _obj;
+  Register _addr;
+  Register _tmp1;
+  Register _tmp2;
+  Register _tmp3;
+  bool _narrow;
+  ShenandoahLoadRefBarrierStubC2(const MachNode* node, Register obj, Register addr, Register tmp1, Register tmp2, Register tmp3, bool narrow) :
+    ShenandoahBarrierStubC2(node), _obj(obj), _addr(addr), _tmp1(tmp1), _tmp2(tmp2), _tmp3(tmp3), _narrow(narrow) {}
+public:
+  static bool needs_barrier(const MachNode* node) {
+    return (node->barrier_data() & (ShenandoahBarrierStrong | ShenandoahBarrierWeak | ShenandoahBarrierPhantom | ShenandoahBarrierNative)) != 0;
+  }
+  static ShenandoahLoadRefBarrierStubC2* create(const MachNode* node, Register obj, Register addr, Register tmp1, Register tmp2, Register tmp3, bool narrow);
+  void emit_code(MacroAssembler& masm) override;
+};
+
+class ShenandoahSATBBarrierStubC2 : public ShenandoahBarrierStubC2 {
+  Register _addr;
+  Register _preval;
+  Register _tmp;
+  ShenandoahSATBBarrierStubC2(const MachNode* node, Register addr, Register preval, Register tmp) :
+    ShenandoahBarrierStubC2(node), _addr(addr), _preval(preval), _tmp(tmp) {}
+
+public:
+  static bool needs_barrier(const MachNode* node) {
+    return (node->barrier_data() & ShenandoahBarrierSATB) != 0;
+  }
+  static ShenandoahSATBBarrierStubC2* create(const MachNode* node, Register addr, Register preval, Register tmp = noreg);
+
+  void emit_code(MacroAssembler& masm) override;
+};
+
+class ShenandoahCASBarrierSlowStubC2 : public ShenandoahBarrierStubC2 {
+  Register _addr_reg;
+  Address  _addr;
+  Register _expected;
+  Register _new_val;
+  Register _result;
+  Register _tmp1;
+  Register _tmp2;
+  bool     _cae;
+  bool     _acquire;
+  bool     _release;
+  bool     _weak;
+
+  explicit ShenandoahCASBarrierSlowStubC2(const MachNode* node, Register addr_reg, Address addr, Register expected, Register new_val, Register result, Register tmp1, Register tmp2, bool cae, bool acquire, bool release, bool weak) :
+    ShenandoahBarrierStubC2(node),
+    _addr_reg(addr_reg), _addr(addr), _expected(expected), _new_val(new_val), _result(result), _tmp1(tmp1), _tmp2(tmp2), _cae(cae), _acquire(acquire), _release(release),  _weak(weak) {}
 
-  virtual bool escape_add_to_con_graph(ConnectionGraph* conn_graph, PhaseGVN* gvn, Unique_Node_List* delayed_worklist, Node* n, uint opcode) const;
-  virtual bool escape_add_final_edges(ConnectionGraph* conn_graph, PhaseGVN* gvn, Node* n, uint opcode) const;
-  virtual bool escape_has_out_with_unsafe_object(Node* n) const;
+public:
+  static ShenandoahCASBarrierSlowStubC2* create(const MachNode* node, Register addr, Register expected, Register new_val, Register result, Register tmp, bool cae, bool acquire, bool release, bool weak);
+  static ShenandoahCASBarrierSlowStubC2* create(const MachNode* node, Address addr, Register expected, Register new_val, Register result, Register tmp1, Register tmp2, bool cae);
+  void emit_code(MacroAssembler& masm) override;
+};
 
-  virtual bool matcher_find_shared_post_visit(Matcher* matcher, Node* n, uint opcode) const;
-  virtual bool matcher_is_store_load_barrier(Node* x, uint xop) const;
+class ShenandoahCASBarrierMidStubC2 : public ShenandoahBarrierStubC2 {
+  ShenandoahCASBarrierSlowStubC2* _slow_stub;
+  Register _expected;
+  Register _result;
+  Register _tmp;
+  bool _cae;
+  ShenandoahCASBarrierMidStubC2(const MachNode* node, ShenandoahCASBarrierSlowStubC2* slow_stub, Register expected, Register result, Register tmp, bool cae) :
+    ShenandoahBarrierStubC2(node), _slow_stub(slow_stub), _expected(expected), _result(result), _tmp(tmp), _cae(cae) {}
+public:
+  static ShenandoahCASBarrierMidStubC2* create(const MachNode* node, ShenandoahCASBarrierSlowStubC2* slow_stub, Register expected, Register result, Register tmp, bool cae);
+  void emit_code(MacroAssembler& masm) override;
 };
 
 #endif // SHARE_GC_SHENANDOAH_C2_SHENANDOAHBARRIERSETC2_HPP
